Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/EvolutionStrategyMainLoop.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/EvolutionStrategyMainLoop.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/EvolutionStrategyMainLoop.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -61,4 +61,7 @@
       get { return (ValueLookupParameter<BoolValue>)Parameters["PlusSelection"]; }
     }
+    public IValueLookupParameter<BoolValue> ReevaluateElitesParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["ReevaluateElites"]; }
+    }
     public ValueLookupParameter<IntValue> MaximumGenerationsParameter {
       get { return (ValueLookupParameter<IntValue>)Parameters["MaximumGenerations"]; }
@@ -108,4 +111,14 @@
       : base() {
       Initialize();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code, remove with 3.4
+      if (!Parameters.ContainsKey("ReevaluateElites")) {
+        Parameters.Add(new ValueLookupParameter<BoolValue>("ReevaluateElites", "Flag to determine if elite individuals should be reevaluated (i.e., if stochastic fitness functions are used.)"));
+      }
+      #endregion
     }
 
@@ -121,4 +134,5 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("MaximumGenerations", "The maximum number of generations which should be processed."));
       Parameters.Add(new ValueLookupParameter<BoolValue>("PlusSelection", "True for plus selection (elitist population), false for comma selection (non-elitist population)."));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("ReevaluateElites", "Flag to determine if elite individuals should be reevaluated (i.e., if stochastic fitness functions are used.)"));
       Parameters.Add(new ValueLookupParameter<IOperator>("Mutator", "The operator used to mutate solutions."));
       Parameters.Add(new ValueLookupParameter<IOperator>("Recombinator", "The operator used to cross solutions."));
@@ -162,4 +176,10 @@
       Placeholder analyzer2 = new Placeholder();
       ConditionalBranch conditionalBranch = new ConditionalBranch();
+      ConditionalBranch reevaluateElitesBranch = new ConditionalBranch();
+      SubScopesProcessor subScopesProcessor2 = new SubScopesProcessor();
+      UniformSubScopesProcessor uniformSubScopesProcessor4 = new UniformSubScopesProcessor();
+      Placeholder evaluator2 = new Placeholder();
+      SubScopesCounter subScopesCounter2 = new SubScopesCounter();
+
 
       variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Generations", new IntValue(0))); // Class EvolutionStrategy expects this to be called Generations
@@ -235,4 +255,15 @@
 
       conditionalBranch.ConditionParameter.ActualName = "Terminate";
+
+      reevaluateElitesBranch.ConditionParameter.ActualName = "ReevaluateElites";
+      reevaluateElitesBranch.Name = "Reevaluate elites ?";
+
+      uniformSubScopesProcessor4.Parallel.Value = true;
+
+      evaluator2.Name = "Evaluator (placeholder)";
+      evaluator2.OperatorParameter.ActualName = EvaluatorParameter.Name;
+
+      subScopesCounter2.Name = "Increment EvaluatedSolutions";
+      subScopesCounter2.ValueParameter.ActualName = EvaluatedSolutionsParameter.Name;
       #endregion
 
@@ -266,5 +297,15 @@
       evaluator.Successor = null;
       subScopesCounter.Successor = null;
-      plusOrCommaReplacementBranch.TrueBranch = plusReplacement;
+
+      plusOrCommaReplacementBranch.TrueBranch = reevaluateElitesBranch;
+      reevaluateElitesBranch.TrueBranch = subScopesProcessor2;
+      reevaluateElitesBranch.FalseBranch = null;
+      subScopesProcessor2.Operators.Add(uniformSubScopesProcessor4);
+      subScopesProcessor2.Operators.Add(new EmptyOperator());
+      uniformSubScopesProcessor4.Operator = evaluator2;
+      uniformSubScopesProcessor4.Successor = subScopesCounter2;
+      subScopesCounter2.Successor = null;
+      reevaluateElitesBranch.Successor = plusReplacement;
+
       plusOrCommaReplacementBranch.FalseBranch = commaReplacement;
       plusOrCommaReplacementBranch.Successor = bestSelector;
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Plugin.cs.frame
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Plugin.cs.frame	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Plugin.cs.frame	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.EvolutionStrategy plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.EvolutionStrategy", "3.3.7.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.EvolutionStrategy", "3.3.10.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.EvolutionStrategy-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Properties/AssemblyInfo.cs.frame	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Properties/AssemblyInfo.cs.frame	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -31,5 +31,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2014 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.7.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.10.$WCREV$")]
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/SelfAdaptiveCrossover.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/SelfAdaptiveCrossover.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/SelfAdaptiveCrossover.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/StrategyVectorManipulator.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/StrategyVectorManipulator.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/StrategyVectorManipulator.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/WithoutRepeatingBatchedRandomSelector.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/WithoutRepeatingBatchedRandomSelector.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.EvolutionStrategy/3.3/WithoutRepeatingBatchedRandomSelector.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
